## cutefish-core-0.4-2.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(core)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(QT Core Gui Widgets Quick QuickControls2 DBus X11Extras LinguistTools)
find_package(Qt5 REQUIRED ${QT})
# find_package(FishUI REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(ECM REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

add_subdirectory(polkit-agent)
add_subdirectory(screen-brightness)
add_subdirectory(session)
add_subdirectory(settings-daemon)
add_subdirectory(shutdown-ui)
add_subdirectory(xembed-sni-proxy)
add_subdirectory(powerman)
add_subdirectory(cpufreq)
add_subdirectory(chotkeys)
add_subdirectory(cupdatecursor)

=== cpufreq/CMakeLists.txt ===
project(cutefish-cpufreq)
set(TARGET cutefish-cpufreq)

set(SOURCES
    main.cpp
)

add_executable(${TARGET} ${SOURCES} ${DBUS_SOURCES})
target_link_libraries(${TARGET}
        Qt5::Core
        Qt5::Quick
        Qt5::DBus
        Qt5::X11Extras
)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES org.cutefish.cpufreq.pkexec.policy DESTINATION /usr/share/polkit-1/actions/)

=== polkit-agent/CMakeLists.txt ===
find_package(PkgConfig)
pkg_check_modules(POLKIT_AGENT REQUIRED polkit-agent-1)
message(STATUS "polkit agent: ${POLKIT_AGENT_INCLUDE_DIRS} ${POLKIT_AGENT_LIBRARIES}")

find_package(PolkitQt5-1 REQUIRED)

include_directories(
    ${POLKIT_AGENT_INCLUDE_DIRS}
    "${POLKITQT-1_INCLUDE_DIR}"
)

add_executable(cutefish-polkit-agent
    main.cpp
    polkitagentlistener.cpp
    dialog.cpp
    qml.qrc
)

target_link_libraries(cutefish-polkit-agent
        Qt5::Core
        Qt5::Widgets
        Qt5::Quick
        Qt5::QuickControls2

        # FishUI

        ${POLKITQT-1_CORE_LIBRARY}
        ${POLKITQT-1_AGENT_LIBRARY}
        ${POLKIT_AGENT_LDFLAGS}
)

file(GLOB TS_FILES translations/*.ts)
qt5_create_translation(QM_FILES ${TS_FILES})
add_custom_target(polkit-agent-translations DEPENDS ${QM_FILES} SOURCES ${TS_FILES})
add_dependencies(cutefish-polkit-agent polkit-agent-translations)

install(TARGETS cutefish-polkit-agent
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT Runtime
)

install(FILES
cutefish-polkit-agent.desktop
    DESTINATION "/etc/xdg/autostart"
    COMPONENT Runtime
)

install(FILES ${QM_FILES} DESTINATION /usr/share/cutefish-polkit-agent/translations)

=== powerman/CMakeLists.txt ===
project(cutefish-powerman)
set(TARGET cutefish-powerman)

set(SOURCES
    main.cpp
    application.cpp
    lidwatcher.cpp
    cpu/cpuitem.cpp
    cpu/cpumanagement.cpp
)

qt5_add_dbus_adaptor(DBUS_SOURCES
                     cpu/org.cutefish.CPUManagement.xml
                     cpu/cpumanagement.h CPUManagement)
set_source_files_properties(${DBUS_SOURCES} PROPERTIES SKIP_AUTOGEN ON)

add_executable(${TARGET} ${SOURCES} ${DBUS_SOURCES})
target_link_libraries(${TARGET}
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::Quick
        Qt5::DBus
        Qt5::X11Extras
)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== screen-brightness/CMakeLists.txt ===
project(cutefish-screen-brightness)
set(PROJECT_NAME cutefish-screen-brightness)

set(SRCS
    main.cpp
    brightnesshelper.h
    brightnesshelper.cpp
)

add_executable(${PROJECT_NAME}
    ${SRCS}
)

target_link_libraries(${PROJECT_NAME}
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
)

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES org.cutefish.brightness.pkexec.policy DESTINATION /usr/share/polkit-1/actions/)

=== session/CMakeLists.txt ===
project(cutefish-session)
set(TARGET cutefish-session)

set(SOURCES
    application.cpp
    main.cpp
    process.cpp
    processmanager.cpp

    powermanager/power.cpp
    powermanager/powerproviders.cpp
)

qt5_add_dbus_adaptor(DBUS_SOURCES
                     org.cutefish.Session.xml
                     application.h Application
                     sessionadaptor SessionAdaptor)
set_source_files_properties(${DBUS_SOURCES} PROPERTIES SKIP_AUTOGEN ON)

find_package(KF5WindowSystem)

add_executable(${TARGET} ${SOURCES} ${DBUS_SOURCES})
target_link_libraries(${TARGET}
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::Quick
        Qt5::DBus
        Qt5::X11Extras
        KF5::WindowSystem
)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES cutefish-xsession.desktop DESTINATION /usr/share/xsessions/)

=== settings-daemon/CMakeLists.txt ===
project(cutefish-settings-daemon)
set(TARGET cutefish-settings-daemon)

find_package(PulseAudio)
find_package(X11 REQUIRED)
pkg_check_modules(XORGLIBINPUT xorg-libinput IMPORTED_TARGET)

file (GLOB_RECURSE SRCS
  "*.cpp"
  "*.h"
  "audio/*.cpp"
  "audio/*.h"
  "theme/*.h"
  "theme/*.cpp"
  "brightness/*.h"
  "brightness/*.cpp"
  "brightness/*.c"
  "battery/*.cpp"
  "battery/*.h"
  "language/*.cpp"
  "language/*.h"
  "dock/*.cpp"
  "dock/*.h"
  "mouse/*.h"
  "mouse/*.cpp"
)

set(SOURCES ${SRCS})
set(HEADERS "")
set(FORMS "")
set(RESOURCES "")

qt5_add_dbus_adaptor(DBUS_SOURCES
                     audio/org.cutefish.Audio.xml
                     audio/audiomanager.h AudioManager)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     brightness/org.cutefish.Brightness.xml
                     brightness/brightnessmanager.h BrightnessManager)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     theme/org.cutefish.Theme.xml
                     theme/thememanager.h ThemeManager)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     battery/org.cutefish.PrimaryBattery.xml
                     battery/battery.h Battery)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     language/org.cutefish.Language.xml
                     language/language.h Language)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     dock/org.cutefish.Dock.xml
                     dock/dock.h Dock)
qt5_add_dbus_adaptor(DBUS_SOURCES
                     mouse/org.cutefish.Mouse.xml
                     mouse/mousemanager.h Mouse)
set_source_files_properties(${DBUS_SOURCES} PROPERTIES SKIP_AUTOGEN ON)

add_executable(${TARGET} ${SOURCES} ${DBUS_SOURCES} ${HEADERS} ${FORMS} ${RESOURCES})
target_link_libraries(${TARGET}
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::DBus
        Qt5::X11Extras
        ${PULSEAUDIO_LIBRARY}
        ${X11_LIBRARIES}
        X11::X11
        X11::Xi
        PkgConfig::XORGLIBINPUT
)

file(GLOB TS_FILES translations/*.ts)
qt5_create_translation(QM_FILES ${TS_FILES})
add_custom_target(translations DEPENDS ${QM_FILES} SOURCES ${TS_FILES})
add_dependencies(${TARGET} translations)

install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${QM_FILES} DESTINATION /usr/share/${TARGET}/translations)

=== shutdown-ui/CMakeLists.txt ===
project(cutefish-shutdown)

add_executable(cutefish-shutdown
    main.cpp
    actions.cpp
    qml.qrc
)

target_link_libraries(cutefish-shutdown
        Qt5::Core
        Qt5::Widgets
        Qt5::Quick
        Qt5::QuickControls2
        Qt5::DBus
)

file(GLOB TS_FILES translations/*.ts)
qt5_create_translation(QM_FILES ${TS_FILES})
add_custom_target(shutdown-translations DEPENDS ${QM_FILES} SOURCES ${TS_FILES})
add_dependencies(cutefish-shutdown shutdown-translations)
install(FILES ${QM_FILES} DESTINATION /usr/share/cutefish-shutdown/translations)

install(TARGETS cutefish-shutdown RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== xembed-sni-proxy/CMakeLists.txt ===
project(cutefish-xembedsniproxy)

add_definitions(-DQT_NO_CAST_TO_ASCII
-DQT_NO_CAST_FROM_ASCII
-DQT_NO_URL_CAST_FROM_STRING
-DQT_NO_CAST_FROM_BYTEARRAY)

find_package(X11)
set_package_properties(X11 PROPERTIES DESCRIPTION "X11 libraries"
                        URL "http://www.x.org"
                        TYPE OPTIONAL
                        PURPOSE "Required for building the X11 based workspace")

if(X11_FOUND)
  find_package(XCB MODULE REQUIRED COMPONENTS XCB RANDR)
  set_package_properties(XCB PROPERTIES TYPE REQUIRED)
  if(NOT X11_SM_FOUND)
    message(FATAL_ERROR "\nThe X11 Session Management (SM) development package could not be found.\nPlease install libSM.\n")
  endif(NOT X11_SM_FOUND)

  find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS X11Extras)
endif()

if(X11_FOUND AND XCB_XCB_FOUND)
  set(HAVE_X11 1)
endif()

find_package(XCB
    REQUIRED COMPONENTS
        XCB
        XFIXES
        DAMAGE
        COMPOSITE
        RANDR
        SHM
        UTIL
        IMAGE
)

find_package(KF5WindowSystem)

set(XCB_LIBS
    XCB::XCB
    XCB::XFIXES
    XCB::DAMAGE
    XCB::COMPOSITE
    XCB::RANDR
    XCB::SHM
    XCB::UTIL
    XCB::IMAGE
)

set(XEMBED_SNI_PROXY_SOURCES
    main.cpp
    fdoselectionmanager.cpp
    snidbus.cpp
    sniproxy.cpp
    xtestsender.cpp
)

qt5_add_dbus_adaptor(DBUS_SOURCES org.kde.StatusNotifierItem.xml
                     sniproxy.h SNIProxy)
set(statusnotifierwatcher_xml org.kde.StatusNotifierWatcher.xml)
qt5_add_dbus_interface(DBUS_SOURCES ${statusnotifierwatcher_xml} statusnotifierwatcher_interface)

set_source_files_properties(${DBUS_SOURCES} PROPERTIES SKIP_AUTOGEN ON)

add_executable(cutefish-xembedsniproxy ${XEMBED_SNI_PROXY_SOURCES} ${DBUS_SOURCES})
set_package_properties(XCB PROPERTIES TYPE REQUIRED)
target_link_libraries(cutefish-xembedsniproxy
    Qt5::Core
    Qt5::X11Extras
    Qt5::DBus
    KF5::WindowSystem
    ${XCB_LIBS}
    ${X11_XTest_LIB}
)

install(TARGETS cutefish-xembedsniproxy DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
cutefish-core (0.1) UNRELEASED; urgency=low

  * Initial release (CutefishOS)  <cutefishos@foxmail.com>

 -- CutefishOS <cutefishos@foxmail.com>  Thu, 16 Oct 2014 17:22:15 +0200

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>

pkgname=cutefish-core
pkgver=0.4
pkgrel=2
pkgdesc="System components and backend of CutefishOS"
arch=('x86_64')
url="https://github.com/cutefishos/core"
license=('GPL')
groups=('cutefish')
depends=('fishui' 'libcutefish' 'libpulse' 'libxcursor' 'libxtst' 'polkit-qt5' 'xf86-input-libinput')
makedepends=('extra-cmake-modules' 'ninja' 'qt5-tools')
source=("https://github.com/cutefishos/core/archive/$pkgver/$pkgname-$pkgver.tar.gz")
sha512sums=('60259469fb1c697ee46c17508ebc508dd40e24d4772a58c52e8cb9a2ccf6debed9dce13296ea3d6f51d612cfc980f46717424216db051d43611a148912bee709')

build() {
  cd core-$pkgver

  cmake -DCMAKE_INSTALL_PREFIX=/usr .
  make
}

package() {
  cd core-$pkgver
  make DESTDIR="$pkgdir" install
}

=== debian/control ===
Source: cutefish-core
Section: devel
Priority: optional
Maintainer: CutefishOS <cutefishos@foxmail.com>
Build-Depends: cmake,
               debhelper (>= 9),
               extra-cmake-modules,
               pkg-config,
               xserver-xorg-input-libinput-dev,
               libxcb1-dev,
               libxcb-randr0-dev,
               libxcb-keysyms1-dev,
               libxcursor-dev,
               libxcb-xfixes0-dev,
               libxcb-damage0-dev,
               libxcb-composite0-dev,
               libxcb-shm0-dev,
               libxcb-util-dev,
               libxcb-image0-dev,
               libxtst-dev,
               libsm-dev,
               libpulse-dev,
               libpolkit-qt5-1-dev,
               libpolkit-agent-1-dev,
               libkf5windowsystem-dev,
               libkf5globalaccel-dev,
               libqt5x11extras5-dev,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtquickcontrols2-5-dev,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.5.0
Homepage: https://github.com/cutefishos/terminal

Package: cutefish-core
Architecture: any
Depends: qml-module-qtquick-controls2,
         qml-module-qtquick2,
         qml-module-qtquick-layouts,
         qml-module-qt-labs-platform,
         qml-module-qt-labs-settings,
         qml-module-qtqml,
         qml-module-qtquick-window2,
         qml-module-qtquick-shapes,
         ${misc:Depends},
         ${shlibs:Depends}
Description: CutefishOS System Components
